﻿
Public Class Form1
    Dim port As Integer
    Dim gp3 As gp3ui

    ' This routine is where data comes in for controls from GP3EZ
    ' You can either call gp3.SetText or handle it yourself
    ' You can also do processing on the data as it whizes by
    Public Sub ProcessControlText(ByVal c As Control, ByVal s As String, ByVal xtra As String)
        ' This is called in your thread so if you want to modify things go ahead
        ' For example, this recalculates Label1's value to be the value * 100
        If c.Name = "Label1" Then
            Dim n As Double
            n = Double.Parse(s)
            n = n * 100.0
            s = n.ToString
        End If
        ' You don't have to call gp3.SetText here -- it just makes the control visible and sets the check or text
        gp3.SetText(c, s, xtra)
    End Sub

    ' This routine is where data comes it from another thread. Don't change this unless
    ' you are sure you know what you are doing
    Public Sub SetControlText(ByVal c As Control, ByVal s As String, ByVal xtra As String)
        ' Note this gets called outside your thread so don't do much here
        gp3.SetText(c, s, xtra, AddressOf ProcessControlText)
    End Sub

    ' Disconnect from GP3EZ on close
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If gp3 IsNot Nothing Then gp3.disconnect()
    End Sub

    ' Set default port
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        port = 333
    End Sub

    ' All buttons should click to this routine or a copy of it
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim b As Button
        b = sender
        gp3.sendString(b.Tag, "+")  ' set tag to gp3ez
    End Sub


    ' Menu items
    Private Sub ConnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectToolStripMenuItem.Click
        ' Connect to a server --
        gp3 = New gp3ui(Me, "localhost", port)
        ' you could elect to launch GP3EZ if you couldn't connect
        Button1.Enabled = gp3.IsConnected
    End Sub

    ' Check and enable items on the file menu
    Private Sub FileToolStripMenuItem_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles FileToolStripMenuItem.DropDownOpening
        If gp3 Is Nothing Then
            ConnectToolStripMenuItem.Checked = False
            ConnectToolStripMenuItem.Enabled = True
            DisconnectToolStripMenuItem.Enabled = False
            SetPortToolStripMenuItem.Enabled = True
        Else
            ConnectToolStripMenuItem.Checked = gp3.IsConnected
            ConnectToolStripMenuItem.Enabled = Not gp3.IsConnected
            DisconnectToolStripMenuItem.Enabled = gp3.IsConnected
            SetPortToolStripMenuItem.Enabled = Not gp3.IsConnected
        End If
        SetPortToolStripMenuItem.Text = "&Set Port (" & port.ToString & ")"
    End Sub
    ' Enable/disable items on the tool menu
    Private Sub ControlToolStripMenuItem_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles ControlToolStripMenuItem.DropDownOpening
        Dim en As Boolean
        If gp3 Is Nothing Then
            en = False
        Else
            en = gp3.IsConnected
        End If
        StartToolStripMenuItem.Enabled = en
        StopToolStripMenuItem.Enabled = en
        ShowToolStripMenuItem.Enabled = en
        HideToolStripMenuItem.Enabled = en
    End Sub
    ' Set a port number (default=333)
    Private Sub SetPortToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetPortToolStripMenuItem.Click
        Dim ps As String
        Dim pnum As Integer

        ps = InputBox("Enter GP3EZ port number", "Enter", port.ToString)
        If ps = "" Then Exit Sub
        If Integer.TryParse(ps, pnum) Then port = pnum
    End Sub

    ' Disconnect menu
    Private Sub DisconnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisconnectToolStripMenuItem.Click
        gp3.disconnect()
        Button1.Enabled = False
    End Sub

    ' Start GP3EZ script
    Private Sub StartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartToolStripMenuItem.Click
        gp3.startscript()
    End Sub
    ' Stop GP3EZ Script
    Private Sub StopToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopToolStripMenuItem.Click
        gp3.stopscript()
    End Sub
    ' Hide GP3EZ
    Private Sub HideToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HideToolStripMenuItem.Click
        gp3.hideGP3EZ()
    End Sub
    ' Show GP3EZ
    Private Sub ShowToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowToolStripMenuItem.Click
        gp3.showGP3EZ()
    End Sub
End Class
